package kartelj.aleksandar.hellospark;

import java.util.Arrays;
import java.util.List;

import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;
import org.apache.spark.api.java.function.Function;
import org.apache.spark.api.java.function.Function2;

/**
 *
 */
public class AppMapAndReduce 
{
    public static void main( String[] args )
    {
        SparkConf conf=new SparkConf();
        conf.setAppName("hellospark");
        conf.setMaster("local[*]");
        
        
        List<Integer> numbers= Arrays.asList(1,2,4,6,4,7,8,9);
        JavaSparkContext sc=new JavaSparkContext(conf);
        JavaRDD<Integer> distributedNumbers=sc.parallelize(numbers);
        Integer result = distributedNumbers.map(new Function<Integer, Integer>() {
        	public Integer call(Integer arg0) throws Exception {
        		return arg0*arg0;
        	}
        }).reduce(new Function2<Integer, Integer, Integer>() {
			
			public Integer call(Integer arg0, Integer arg1) throws Exception {
				return arg0+arg1;
			}
		});
        System.out.println(result);
    }
}
