package kartelj.aleksandar.hellospark;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.spark.SparkConf;
import org.apache.spark.api.java.JavaRDD;
import org.apache.spark.api.java.JavaSparkContext;

/**
 * http://spark.apache.org/docs/latest/programming-guide.html
 */

public class AppMapAndReduceFileWithLambda {
	static boolean hasUppercase(String str) {
		Pattern pattern = Pattern.compile("[A-Z]");
		Matcher matcher = pattern.matcher(str);
		return matcher.find();
	}

	static int sumAscii(String str) {
		int sum = 0;
		for (int i = 0; i < str.length(); i++)
			sum += str.charAt(i);
		return sum;
	}

	public static void main(String[] args) {
		SparkConf conf = new SparkConf();
		conf.setAppName("hellospark");
		conf.setMaster("local[*]");

		JavaSparkContext sc = new JavaSparkContext(conf);
		JavaRDD<String> lines = sc.textFile("src/tekst.txt");
		Integer result = lines.filter(x -> hasUppercase(x))
				.map(x -> sumAscii(x)).reduce((x, y) -> x + y);
		System.out.println(result); 
	}
}
